unit KepMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls;

type
  TFormMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Transform1: TMenuItem;
    Brightness1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Sharpen1: TMenuItem;
    Sharpen2: TMenuItem;
    Average1: TMenuItem;
    Gaussian1: TMenuItem;
    N1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    SpecialTransf1: TMenuItem;
    Gradient1: TMenuItem;
    Gradient2: TMenuItem;
    Derivate1: TMenuItem;
    Reset1: TMenuItem;
    Binary1: TMenuItem;
    ConverttoBinary: TMenuItem;
    Erosion1: TMenuItem;
    Dilation1: TMenuItem;
    View1: TMenuItem;
    Histogram1: TMenuItem;
    N5: TMenuItem;
    VertEdg: TMenuItem;
    HorEdg: TMenuItem;
    N6: TMenuItem;
    Laplace1: TMenuItem;
    Laplace2: TMenuItem;
    Sobel: TMenuItem;
    Sobel2: TMenuItem;
    Prewitt: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Brightness1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Sharpen1Click(Sender: TObject);
    procedure Sharpen2Click(Sender: TObject);
    procedure Average1Click(Sender: TObject);
    procedure Gaussian1Click(Sender: TObject);
    procedure Gradient1Click(Sender: TObject);
    procedure Gradient2Click(Sender: TObject);
    procedure Derivate1Click(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure ConverttoBinaryClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Erosion1Click(Sender: TObject);
    procedure Dilation1Click(Sender: TObject);
    procedure Histogram1Click(Sender: TObject);
    procedure VertEdgClick(Sender: TObject);
    procedure HorEdgClick(Sender: TObject);
    procedure Laplace1Click(Sender: TObject);
    procedure Laplace2Click(Sender: TObject);
    procedure SobelClick(Sender: TObject);
    procedure Sobel2Click(Sender: TObject);
    procedure PrewittClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

ttip = array[1..9]of integer;
procedure Transform(t:ttip;oszt:byte);
function zart(w:word):boolean;
function szelso(w:word):boolean;

var
  FormMain: TFormMain;
  Bitmap,Bitmap1:TBitmap;
  PPict,PPict1:PChar;
  sor,oszl:integer;
  PSize:word;
  BitmapFileHeader:TBitmapFileHeader;
  BitmapInfo:^TBitmapInfo;

implementation
uses KepP,KepBr,KepConv, KepHist;
{$R *.DFM}

procedure TFormMain.Open1Click(Sender: TObject);
var f:file;
    i:integer;
    w:word;
begin
  with OpenDialog1 do
    if Execute then
      begin
        if Assigned(FormP) then FormP.Close;
        Bitmap:=TBitmap.Create;
        Bitmap1:=TBitmap.create;
        Bitmap.LoadFromFile(FileName);
        Bitmap1.LoadFromFile(FileName);
        sor:=Bitmap.Height; oszl:=Bitmap.Width;
        PSize:=sor*oszl;
        FormP:=TFormP.Create(Self);
        FormP.Canvas.Draw(0,0,Bitmap);
        AssignFile(f,FileName);
        Reset(f,1);
        BitmapInfo:=MemAlloc(SizeOf(TBitmapInfoHeader)+256*SizeOf(TRGBQuad));
        BlockRead(f,BitmapFileHeader,sizeof(BitmapFileHeader));
        BlockRead(f,BitmapInfo^,SizeOf(TBitmapInfoHeader)+256*SizeOf(TRGBQuad));
        GetMem(PPict,PSize+1);
        GetMem(PPict1,PSize+1);
        BlockRead(f,PPict^,PSize);
        CloseFile(f);
        for w:=0 to PSize-1 do (PPict1+w)^:=(PPict+w)^;
        SelectPalette(FormP.Canvas.Handle,bitmap.palette,false);
        RealizePalette(FormP.Canvas.Handle);
        Transform1.Enabled:=true;
        SpecialTransf1.Enabled:=true;
        FormMain.Save1.Enabled:=true;
        FormMain.Saveas1.Enabled:=true;
        Binary1.Enabled:=true;
        Histogram1.Enabled:=true;
      end
end;

procedure TFormMain.Exit1Click(Sender: TObject);
begin
  Close
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if Assigned(Bitmap) then Bitmap.Free;
 if Assigned(Bitmap1) then Bitmap1.Free;
 if Assigned(FormP) then FormP.Free;
 if Assigned(PPict) then FreeMem(PPict,PSize+1);
 if Assigned(PPict1) then FreeMem(PPict1,PSize+1);
 if Assigned(BitmapInfo) then
  FreeMem(BitmapInfo,SizeOf(TBitmapInfoHeader)+256*SizeOf(TRGBQuad));
end;

procedure TFormMain.Brightness1Click(Sender: TObject);
begin
 Brightn.BorderIcons:=Brightn.BorderIcons-[biMaximize,biMinimize];
 Brightn.ScrollBar1.Position:=0;
 Brightn.Label1.Caption:='50';
 Brightn.ShowModal;
end;

procedure TFormMain.Save1Click(Sender: TObject);
var f:file;
begin
 AssignFile(f,FormP.Caption);
 Reset(f,1);
 Seek(f,1078);
 BlockWrite(f,PPict1^,PSize);
 CloseFile(f);
end;

procedure TFormMain.SaveAs1Click(Sender: TObject);
var freg,fuj:file;
    p:pointer;
begin
 with SaveDialog1 do
  if execute then
   begin
    AssignFile(freg,FormP.Caption);
    AssignFile(fuj,FileName);
    Reset(freg,1);
    Rewrite(fuj,1);
    GetMem(p,1078);
    BlockRead(freg,p^,1078);
    BlockWrite(fuj,p^,1078);
    FreeMem(p,1078);
    BlockWrite(fuj,PPict1^,PSize);
    CloseFile(freg);
    CloseFile(fuj);
    FormP.Caption:=FileName
   end
end;

procedure Transform(t:ttip;oszt:byte);
var i,j,k:integer;
    w:word;
begin
 FormMain.Cursor:=crHourGlass;
 SelectPalette(FormP.Canvas.Handle,bitmap.palette,false);
 RealizePalette(FormP.Canvas.Handle);
 for i:=2 to sor-1 do
  for j:=2 to oszl-1 do
   begin
    k:=round((t[1]*ord((PPict+((i-2)*oszl+j-2))^)+
              t[2]*ord((PPict+((i-2)*oszl+j-1))^)+
              t[3]*ord((PPict+((i-2)*oszl+j))^)+
              t[4]*ord((PPict+((i-1)*oszl+j-2))^)+
              t[5]*ord((PPict+((i-1)*oszl+j-1))^)+
              t[6]*ord((PPict+((i-1)*oszl+j))^)+
              t[7]*ord((PPict+(i*oszl+j-2))^)+
              t[8]*ord((PPict+(i*oszl+j-1))^)+
              t[9]*ord((PPict+(i*oszl+j))^))/oszt);
    if k>255 then (PPict1+((i-1)*oszl+j-1))^:=#255
    else if k<0 then (PPict1+((i-1)*oszl+j-1))^:=#0
    else (PPict1+((i-1)*oszl+j-1))^:=chr(k)
   end;
 Bitmap1.handle:=CreateDIBitmap(FormP.Canvas.Handle,BitmapInfo^.bmiHeader,cbm_Init,
                                PPict1,BitmapInfo^,DIB_RGB_Colors);
 FormP.Canvas.Draw(0,0,Bitmap1);
 for w:=0 to PSize do (PPict+w)^:=(PPict1+w)^;
 FormMain.Cursor:=crDefault;
 if FormMain.Histogram1.Checked then
  begin
   Esorszam:=-1;
   fest;
  end
end;

procedure TFormMain.Sharpen1Click(Sender: TObject);
const t:ttip=( 0,-1, 0,
              -1, 5,-1,
               0,-1, 0);
begin
 Transform(t,1)
end;

procedure TFormMain.Sharpen2Click(Sender: TObject);
const t:ttip=(-1,-1,-1,
              -1, 9,-1,
              -1,-1,-1);
begin
 Transform(t,1)
end;

procedure TFormMain.Average1Click(Sender: TObject);
const t:ttip=(1,1,1,
              1,1,1,
              1,1,1);
begin
 Transform(t,9)
end;

procedure TFormMain.Gaussian1Click(Sender: TObject);
const t:ttip=(1,2,1,
              2,4,2,
              1,2,1);
begin
 Transform(t,16)
end;

procedure TFormMain.Gradient1Click(Sender: TObject);
const t:ttip=(1,1,1,
              1,-2,-1,
              1,-1,-1);
begin
 Transform(t,1)
end;

procedure TFormMain.Gradient2Click(Sender: TObject);
const t:ttip=( 1, 0, 1,
               0, 0, 0,
              -1, 0,-1);
begin
 Transform(t,1)
end;

procedure TFormMain.Derivate1Click(Sender: TObject);
const t:ttip=( 1, 1, 0,
               1, 0,-1,
               0,-1,-1);
begin
 Transform(t,1)
end;

procedure TFormMain.VertEdgClick(Sender: TObject);
const t:ttip=( 1, 1,-1,
               1,-2,-1,
               1, 1,-1);
begin
 Transform(t,1)
end;

procedure TFormMain.HorEdgClick(Sender: TObject);
const t:ttip=(-1,-1,-1,
               1,-2, 1,
               1, 1, 1);
begin
 Transform(t,1)
end;

procedure TFormMain.Laplace1Click(Sender: TObject);
const t:ttip=( 0,-1, 0,
              -1, 4,-1,
               0,-1, 0);
begin
 Transform(t,1)
end;

procedure TFormMain.Laplace2Click(Sender: TObject);
const t:ttip=(-1,-1,-1,
              -1, 8,-1,
              -1,-1,-1);
begin
 Transform(t,1)
end;

procedure TFormMain.SobelClick(Sender: TObject);
const t:ttip=( 1, 2, 1,
               0, 0, 0,
              -1,-2,-1);
begin
 Transform(t,1)
end;

procedure TFormMain.Sobel2Click(Sender: TObject);
const t:ttip=( 1, 0,-1,
               2, 0,-2,
               1, 0,-1);
begin
 Transform(t,1)
end;

procedure TFormMain.PrewittClick(Sender: TObject);
const t:ttip=( 1, 1, 1,
               1,-2,-1,
               1,-1,-1);
begin
 Transform(t,1)
end;

procedure TFormMain.Reset1Click(Sender: TObject);
var i,j:integer;
    w:word;
begin
 FormMain.Cursor:=crHourGlass;
 SelectPalette(FormP.Canvas.Handle,bitmap.palette,false);
 RealizePalette(FormP.Canvas.Handle);
 for i:=0 to sor-1 do
  for j:=0 to oszl-1 do
    (PPict+i*oszl+j)^:=chr(Bitmap.Canvas.Pixels[j,sor-i-1]);
 Bitmap1.handle:=CreateDIBitmap(FormP.Canvas.Handle,BitmapInfo^.bmiHeader,cbm_Init,
                                PPict,BitmapInfo^,DIB_RGB_Colors);
 for w:=0 to PSize do (PPict1+w)^:=(PPict+w)^;
 FormP.Canvas.Draw(0,0,Bitmap1);
 FormMain.Cursor:=crDefault;
 Brightness1.Enabled:=true;
 Sharpen1.Enabled:=true;
 Sharpen2.Enabled:=true;
 Average1.Enabled:=true;
 Gaussian1.Enabled:=true;
 SpecialTransf1.Enabled:=true;
 ConverttoBinary.Enabled:=true;
 Erosion1.Enabled:=false;
 Dilation1.Enabled:=false;
 if FormMain.Histogram1.Checked then
  begin
  Esorszam:=-1;
  fest;
 end
end;

procedure TFormMain.ConverttoBinaryClick(Sender: TObject);
var w:word;
begin
 ConvForm.BorderIcons:=ConvForm.BorderIcons-[biMaximize,biMinimize];
 ConvForm.ScrollBar1.Position:=50;
 ConvForm.Label1.Caption:='50';
 if ConvForm.ShowModal = mrOk then
  begin
   for w:=0 to PSize do (PPict+w)^:=(PPict1+w)^;
   Brightness1.Enabled:=false;
   Sharpen1.Enabled:=false;
   Sharpen2.Enabled:=false;
   Average1.Enabled:=false;
   Gaussian1.Enabled:=false;
   SpecialTransf1.Enabled:=false;
   ConverttoBinary.Enabled:=false;
   Erosion1.Enabled:=true;
   Dilation1.Enabled:=true;
  end
 else
  for w:=0 to PSize do (PPict1+w)^:=(PPict+w)^;
 SelectPalette(FormP.Canvas.Handle,bitmap.palette,false);
 RealizePalette(FormP.Canvas.Handle);
 Bitmap1.handle:=CreateDIBitmap(FormP.Canvas.Handle,BitmapInfo^.bmiHeader,cbm_Init,
                                PPict1,BitmapInfo^,DIB_RGB_Colors);
 FormP.Canvas.Draw(0,0,Bitmap1);
 if FormMain.Histogram1.Checked then
  begin
  Esorszam:=-1;
  fest;
 end
end;

function zart(w:word):boolean;
begin
 if (w<oszl) or (w>PSize-oszl-1) then zart:=true else
 if ((PPict+w-1)^=#0)and((PPict+w+1)^=#0)and((PPict+w-oszl)^=#0)and
    ((PPict+w+oszl)^=#0) then zart:=true
 else zart:=false;
end;

function szelso(w:word):boolean;
begin
 if (w<oszl) or (w>PSize-oszl-1) then szelso:=false else
 if ((PPict+w-1)^=#0)or((PPict+w+1)^=#0)or((PPict+w-oszl)^=#0)or
    ((PPict+w+oszl)^=#0) then szelso:=true
 else szelso:=false;
end;

procedure TFormMain.Erosion1Click(Sender: TObject);
var w:word;
begin
 for w:=0 to PSize do
  if ((PPict+w)^=#0) and not zart(w) then
   (PPict1+w)^:=#255;
 for w:=0 to PSize do (PPict+w)^:=(PPict1+w)^;
 SelectPalette(FormP.Canvas.Handle,bitmap.palette,false);
 RealizePalette(FormP.Canvas.Handle);
 Bitmap1.handle:=CreateDIBitmap(FormP.Canvas.Handle,BitmapInfo^.bmiHeader,cbm_Init,
                                PPict1,BitmapInfo^,DIB_RGB_Colors);
 FormP.Canvas.Draw(0,0,Bitmap1);
 if FormMain.Histogram1.Checked then
  begin
  Esorszam:=-1;
  fest;
 end
end;

procedure TFormMain.Dilation1Click(Sender: TObject);
var w:word;
begin
 for w:=0 to PSize do
  if ((PPict+w)^=#255) and szelso(w) then
   (PPict1+w)^:=#0;
 for w:=0 to PSize do (PPict+w)^:=(PPict1+w)^;
 SelectPalette(FormP.Canvas.Handle,bitmap.palette,false);
 RealizePalette(FormP.Canvas.Handle);
 Bitmap1.handle:=CreateDIBitmap(FormP.Canvas.Handle,BitmapInfo^.bmiHeader,cbm_Init,
                                PPict1,BitmapInfo^,DIB_RGB_Colors);
 FormP.Canvas.Draw(0,0,Bitmap1);
 if FormMain.Histogram1.Checked then
  begin
  Esorszam:=-1;
  fest;
 end
end;

procedure TFormMain.Histogram1Click(Sender: TObject);
begin
 Histogram1.checked:=not Histogram1.checked;
 if Histogram1.checked then
 HistForm:=THistForm.Create(Self) else HistForm.Close;
end;

end.
